/*  Crystality Plugin - A plugin for remastering mp3 sound in realtime
 *
 *  Copyright (C) 2001 Rafal Bosak <gyver@fanthom.irc.pl>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <stdio.h>
#include <stdlib.h>

#include <audacious/plugin.h>
#include <audacious/configdb.h>
#include "crystality.h"

int process_sound_xmms(gpointer *data, gint length, AFormat afmt, gint srate, gint nch);

EffectPlugin extender_ep = {
	.description = "Crystality Plugin v0.93",
	.init = init,
	.cleanup = cleanup,
	.about = about,
	.configure = configure,
	.mod_samples = process_sound_xmms,
};

EffectPlugin *extender_eplist[] = { &extender_ep, NULL };

DECLARE_PLUGIN(echo, NULL, NULL, NULL, NULL, extender_eplist, NULL, NULL, NULL);

int read_config(void)
{
    ConfigDb *cfg;

    cfg = aud_cfg_db_open();

    if (aud_cfg_db_get_int(cfg, "Extender-DSP", "expander", &bext_level)){
	aud_cfg_db_get_int(cfg, "Extender-DSP", "echo", &echo_level);
	aud_cfg_db_get_int(cfg, "Extender-DSP", "stereo", &stereo_level);
	aud_cfg_db_get_int(cfg, "Extender-DSP", "filter", &filter_level);
	aud_cfg_db_get_int(cfg, "Extender-DSP", "feedback", &feedback_level);
	aud_cfg_db_get_int(cfg, "Extender-DSP", "harmonics", &harmonics_level);
	aud_cfg_db_close(cfg);
	return 1;
    } else {
	set_defaults();
	return -1;
    }
}

int write_config(void)
{
    ConfigDb *cfg;

    cfg = aud_cfg_db_open();
    if (cfg) {
	aud_cfg_db_set_int(cfg, "Extender-DSP", "expander", bext_level);
	aud_cfg_db_set_int(cfg, "Extender-DSP", "echo", echo_level);
	aud_cfg_db_set_int(cfg, "Extender-DSP", "stereo", stereo_level);
	aud_cfg_db_set_int(cfg, "Extender-DSP", "filter", filter_level);
	aud_cfg_db_set_int(cfg, "Extender-DSP", "feedback", feedback_level);
	aud_cfg_db_set_int(cfg, "Extender-DSP", "harmonics", harmonics_level);
	aud_cfg_db_close(cfg);
	return 1;
    } else {
	return -1;
    }
}

int process_sound_xmms(gpointer *data, gint length, AFormat afmt, gint srate, gint nch)
{
    process_sound((void*)*data, (int)length, (int)afmt, (int)srate, (int)nch);
    return length;
}

